from abstractagent import AbstractAgent
from blackjack import BlackjackEnv, BlackjackObservation
from carddeck import *


class AdvancedAgent(AbstractAgent):
    """
    Implementation of this file is optional!

    What should be included in this file is part of the optional work for advanced students, refer to section 4 of the
    project specification.
    """

    def train(self):
        for i in range(self.number_of_episodes):
            print(i)
            observation = self.env.reset()
            # This implementation is optional!

        # TODO save the model (i.e. NN weights or similar parameters) once learning is finished
        raise NotImplementedError('Implement the agent first!')

    def get_hypothesis(self, observation: BlackjackObservation, terminal: bool, action: int) -> float:
        """
        Implement this method so that I can test your code. This method is supposed to return your learned Q value for
        particular observation and action.

        :param observation: The observation as in the game. Contains information about what the player sees - player's
        hand and dealer's hand.
        :param terminal: Whether the hands were seen after the end of the game, i.e. whether the state is terminal.
        :param action: Action for Q-value.
        :return: The learned Q-value for the given observation and action.
        """
        pass

    def load_model(self):
        """
        Calling this method will cause the agent to load the model into its state. The agent should store the model in
        the file once learning is finished and this method will load the results.
        :return: None.
        """
        pass
